char version[31 + 1] = "1",
     release[31 + 1] = "2",
     revision[31 + 1] = "10",
     fname[31 + 1] = "C_START",
     productcode[31 + 1] = "C_START";

#include "imp2c.h"

int
main (int argc, char **argv)
{
  const int maxknown = 76;
#define true 1
#define false 0
  int i;
  int size;
  int laser = false;
  int m5500 = false;
  int mebes = false;
  int unix_ = true;
  int notit = false;
  char custcode[3 + 1];
  char file[127 + 1], line[127 + 1], host[127 + 1], spc[127 + 1] = "";
  char *s;

  void checkunix ()
  {
    FILE *test = fopen("MISC_DIR:PELLICLE_DB.CLIB", "rb");
    if (test != NULL) {
      fclose(test);
      unix_ = false;
    }
  }

  imp_init(argc, argv);
  if (qualifierpresent ("IDENTIFY"))
    {
      printidentification ();
      exit(1);
    }
  if (qualifierpresent ("LASER"))
    laser = true;
  if (qualifierpresent ("5500"))
    m5500 = true;
  if (qualifierpresent ("MEBES"))
    mebes = true;
  if (qualifierpresent ("NOTIT"))
    notit = true;
  checkunix ();
  strcpy(file, qualifiers ("FILES"));
  if (*file == '\0')
    {
      selectinput (0);
      spawncommand ("ls *.jb");
      prompt ("Enter .JB name: ");
      readline (file, sizeof(file));
    }
  if (!(strchr (file, '.')))
    strcat (file, ".jb");
  strcpy(custcode, substring (file, 1, 3));
  imp_tolower (custcode);
  if (!openinput (1, file))
    {
      fatalerror ("Unable to open %s", file);
    }
  selectinput (1);
  if (!openoutput (1, "cats_start.cinc"))
    {
      fatalerror ("Unable to open cats_start.cinc");
    }
  selectoutput (1);
  for (;;)
    {
      readline (line, sizeof(line));
      if (strlen (line) < 3)
	continue;
      if ((strcmp (substring (line, 1, 3), "END") == 0))
	break;
      if (strlen (line) < 7)
	continue;
      if ((strcmp (substring (line, 1, 5), "SLICE") == 0))
	{
	  if (*line == ',')
	    {
              memmove(line, line+1, sizeof(line)-1); line[sizeof(line)-1]='\0';
	    }
	  if ((strcmp (substring (line, 1, 2), "10") == 0))
	    {
	      size = 3;
	    }
	  else if ((strcmp (substring (line, 1, 2), "13") == 0))
	    {
	      size = 4;
	    }
	  else if ((strcmp (substring (line, 1, 2), "14") == 0))
	    {
	      size = 5;
	    }
	  else if ((strcmp (substring (line, 1, 2), "17") == 0))
	    {
	      size = 6;
	    }
	  else if ((strcmp (substring (line, 1, 2), "19") == 0))
	    {
	      size = 7;
	    }
	  else if ((strcmp (substring (line, 1, 2), "22") == 0))
	    {
	      size = 8;
	    }
	  else
	    {
	      fatalerror ("Unable to determine slice code");
	    }
	}
      else if ((s = strstr(line, "THESE ARE SPC CELL PLACEMENTS FOR ")) != NULL)
	{
          memmove(line, s + strlen("THESE ARE SPC CELL PLACEMENTS FOR "),
                        strlen(s + strlen("THESE ARE SPC CELL PLACEMENTS FOR "))+1);
	  if ((strcmp (line, "ASM03P") == 0))
	    {
	      strcpy (spc, "Struct ASM03");
	      break;
	    }
	  else if ((strcmp (line, "ASM07P") == 0))
	    {
	      strcpy (spc, "Struct ASM07");
	      break;
	    }
	  else if ((strcmp (line, "ASM 6\" 5500/80") == 0))
	    {
	      strcpy (spc, "Struct ASM14");
	      break;
	    }
	  else if ((strcmp (line, "ASM 6\" ASM17P") == 0))
	    {
	      strcpy (spc, "Struct ASM17");
	      break;
	    }
	  else if ((strcmp (line, "CANON SF") == 0))
	    {
	      if ((strcmp (custcode, "mie") == 0)
		  || (strcmp (custcode, "eri") == 0)
		  || (strcmp (custcode, "zar") == 0)
		  || (strcmp (custcode, "xfa") == 0))
		{
		  strcpy (spc, "Struct CAN14");
		}
	      else if ((strcmp (custcode, "sta") == 0))
		{
		  strcpy (spc, "Struct CAN07");
		}
	      else
		{
		  warningmessage
		    ("Please advise JGH of this job to fix C_START");
		}
	      break;
	    }
	  else if ((strcmp (line, "CANON WF") == 0))
	    {
	      if ((strcmp (custcode, "zar") == 0)
		  || (strcmp (custcode, "mek") == 0)
		  || (strcmp (custcode, "mie") == 0)
		  || (strcmp (custcode, "xfa") == 0))
		{
		  strcpy (spc, "Struct CAN28");
		}
	      else if ((strcmp (custcode, "sta") == 0))
		{
		  strcpy (spc, "Struct CAN43");
		}
	      else if ((strcmp (custcode, "mic") == 0))
		{
		  strcpy (spc, "");
		}
	      else
		{
		  warningmessage
		    ("Please advise JGH of this job to fix C_START");
		}
	      break;
	    }
	  else if (strstr (line, ("CAN62P")))
	    {
	      strcpy (spc, "Struct CAN62P");
	      break;
	    }
	  else if ((strcmp (line, "GCA SF") == 0))
	    {
	      strcpy (spc, "Struct GCA04");
	      break;
	    }
	  else if ((strcmp (line, "GCA WF") == 0))
	    {
	      strcpy (spc, "Struct GCA06");
	      break;
	    }
	  else if ((strcmp (line, "PE 4\" RND") == 0))
	    {
	      strcpy (spc, "Struct PE02");
	      break;
	    }
	  else if ((strcmp (line, "PE 6\" RND") == 0))
	    {
	      strcpy (spc, "Struct PE05");
	      break;
	    }
	  else if ((strcmp (line, "NIKON 6\" BODY 8") == 0))
	    {
	      strcpy (spc, "Struct NIK17");
	      break;
	    }
	  else if ((strcmp (line, "NIKON 6\" BODY 9-11") == 0)
		   || (strcmp (line, "NIKON 6\" BODY 9") == 0))
	    {
	      strcpy (spc, "Struct NIK40");
	      break;
	    }
	  else if ((strcmp (line, "NIKON 6\" TI08") == 0))
	    {
	      strcpy (spc, "Struct NIK_6_TI08");
	      break;
	    }
	  else if ((strcmp (line, "NIKON SF") == 0))
	    {
	      strcpy (spc, "Struct NIK01");
	      break;
	    }
	  else if ((strcmp (line, "NIKON WF") == 0))
	    {
	      strcpy (spc, "Struct NIK25");
	      break;
	    }
	  else if ((strcmp (line, "NIKON WF ROT") == 0)
		   || (strcmp (line, "ROTATED NIKON WF") == 0))
	    {
	      strcpy (spc, "Struct NIK25_ROT");
	      break;
	    }
	  else if ((strcmp (line, "ROTATED ULTRATECH 5\"X3\"") == 0))
	    {
	      strcpy (spc, "Struct UT01_ROT_5X3");
	      break;
	    }
	  else if ((strcmp (line, "ULTRATECH UT14") == 0))
	    {
	      strcpy (spc, "Struct UT14");
	      break;
	    }
	}
    }
  selectinput (0);
  prompt ("Enter .JB level: ");
  readline (line, sizeof(line));
  fprintf (outfile, "LAYER %s\n", file);
  fprintf (outfile, "INPUT %s\n", file);
  fprintf (outfile, "ONGRID 0.125\n");
  fprintf (outfile, "If ({ongrid_best} == \"0\")\n");
  fprintf (outfile, "   RESOL 0.127\n");
  fprintf (outfile, "Else\n");
  fprintf (outfile, "   RESOL {ongrid_best}\n");
  fprintf (outfile, "End If\n");
  fprintf (outfile, "FUNCT OR\n");
  fprintf (outfile, "SWITCH\n");
  if (unix_ == true)
    {
      fprintf (outfile, "INPUT /cgi/stdjob/pellicle.gds\n");
    }
  else
    {
      fprintf (outfile, "INPUT MISC_DIR:pellicle_db.clib\n");
    }
  if (strcmp (spc, ""))
    {
      fprintf (outfile, "%s\n", spc);
      fprintf (outfile, "LAYER ");
      fprintf (outfile, "1,4,5");
      if (size == 6 && m5500 == true && notit == false)
	fprintf (outfile, ",9");
      if (m5500 == true || mebes == true)
	fprintf (outfile, ",13");
      fprintf (outfile, "\n");
    }
  else
    {
      if (3 <= size && size <= 7)
	{
	  fprintf (outfile, "STRUCT MEBES_%c\n", size + '0');
	}
      else if (size == 8)
	{
	  fprintf (outfile, "STRUCT MEBES_7_25R\n");
	}
      else
	{
	  fatalerror ("Unable to decide on SLICE code or SPC cell name");
	}
      fprintf (outfile, "LAYER ");
      fprintf (outfile, "1,5,6");
      if (size == 6 && m5500 == true && notit == false)
	fprintf (outfile, ",9");
      if (m5500 == true || mebes == true)
	fprintf (outfile, ",13");
    }
  fprintf (outfile, "\n");
  fprintf (outfile, "EXTENT\n");
  fprintf (outfile, "SWITCH\n");
  exit(0);
  return(0);
}
